package b4a.dji.waldo;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.dji.waldo", "b4a.dji.waldo.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.dji.waldo", "b4a.dji.waldo.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.dji.waldo.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.DJISDKManagerWrapper _sdk = null;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public static anywheresoftware.b4a.objects.Timer _updatemaptimer = null;
public static anywheresoftware.b4a.objects.DJIAircraftWrapper _aircraft = null;
public static anywheresoftware.b4a.objects.DJIFlightControllerWrapper _controller = null;
public static anywheresoftware.b4a.objects.DJICameraWrapper _camera = null;
public static String _aircraftname = "";
public static int _batterylevel = 0;
public static anywheresoftware.b4a.objects.MapFragmentWrapper.CameraPositionWrapper _cp = null;
public static String _flightmodemavic = "";
public static int _gpsstatusmavic = 0;
public static int _altitudemavic = 0;
public static int _speedmavic = 0;
public static int _rateofclimbmavic = 0;
public static boolean _homelocationsetmavic = false;
public static int _rcsignalstrenghtmavic = 0;
public static double _latitudemavic = 0;
public static double _longitudemavic = 0;
public static double _homelocationlatitudemavic = 0;
public static double _homelocationlongitudemavic = 0;
public static double _lastlongitudemavic = 0;
public static double _lastlatitudemavic = 0;
public static boolean _homelocationdrawn = false;
public static float _zoom = 0f;
public static int _ssc = 0;
public static anywheresoftware.b4a.objects.MapFragmentWrapper.MarkerWrapper _mavicmarker = null;
public static anywheresoftware.b4a.objects.MapFragmentWrapper.MarkerWrapper _waypointmarker = null;
public static anywheresoftware.b4a.objects.MapFragmentWrapper.MarkerWrapper _homemarker = null;
public static String _imu = "";
public static anywheresoftware.b4a.phone.Phone.PhoneWakeState _pws = null;
public static anywheresoftware.b4a.gps.GPS _gpsclient = null;
public static anywheresoftware.b4a.gps.LocationWrapper _userlocation = null;
public static anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper _waypointoperator = null;
public static String _missionstatus = "";
public static anywheresoftware.b4a.objects.DJICameraCaptureWidgetWrapper _djicameracapturewidget1 = null;
public static anywheresoftware.b4a.objects.DJIRemoteControlSignalWidgetWrapper _djiremotecontrolsignalwidget1 = null;
public static anywheresoftware.b4a.objects.DJIDistanceRCWidgetWrapper _djidistancercwidget1 = null;
public static anywheresoftware.b4a.objects.DJIRemainingFlightTimeWidgetWrapper _djiremainingflighttimewidget1 = null;
public static anywheresoftware.b4a.objects.DJIVerticalVelocityWidgetWrapper _djiverticalvelocitywidget1 = null;
public static anywheresoftware.b4a.objects.DJIDashboardWidgetWrapper _djidashboardwidget1 = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlcamera = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbltext = null;
public anywheresoftware.b4a.objects.LabelWrapper _labelaircraftname = null;
public anywheresoftware.b4a.objects.LabelWrapper _labelbattery = null;
public anywheresoftware.b4a.objects.LabelWrapper _labelgpsstatus = null;
public anywheresoftware.b4a.objects.LabelWrapper _labelflightmode = null;
public anywheresoftware.b4a.objects.LabelWrapper _labelaltitude = null;
public anywheresoftware.b4a.objects.LabelWrapper _labelverticalspeed = null;
public anywheresoftware.b4a.objects.LabelWrapper _labelspeed = null;
public anywheresoftware.b4a.objects.LabelWrapper _labelrcsignalstrength = null;
public anywheresoftware.b4a.objects.LabelWrapper _labelhomelocationset = null;
public anywheresoftware.b4a.objects.LabelWrapper _labelssc = null;
public anywheresoftware.b4a.objects.MapFragmentWrapper.GoogleMapWrapper _gmap = null;
public anywheresoftware.b4a.objects.MapFragmentWrapper _mapfragment1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _startmissionbutton = null;
public anywheresoftware.b4a.objects.ButtonWrapper _stopmissionbutton = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _homeicon = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _waypointicon = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _mavicicon = null;
public static boolean _waypointmissionrunning = false;
public b4a.dji.waldo.starter _starter = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static void  _activity_create(boolean _firsttime) throws Exception{
ResumableSub_Activity_Create rsub = new ResumableSub_Activity_Create(null,_firsttime);
rsub.resume(processBA, null);
}
public static class ResumableSub_Activity_Create extends BA.ResumableSub {
public ResumableSub_Activity_Create(b4a.dji.waldo.main parent,boolean _firsttime) {
this.parent = parent;
this._firsttime = _firsttime;
}
b4a.dji.waldo.main parent;
boolean _firsttime;
boolean _success = false;
String _errormessage = "";

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
                return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 94;BA.debugLine="Activity.LoadLayout(\"1\")";
parent.mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 96;BA.debugLine="HomeIcon.Initialize(File.DirAssets, \"home.jpg\")";
parent.mostCurrent._homeicon.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"home.jpg");
 //BA.debugLineNum = 97;BA.debugLine="WaypointIcon.Initialize(File.DirAssets, \"destinat";
parent.mostCurrent._waypointicon.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"destination.jpg");
 //BA.debugLineNum = 98;BA.debugLine="MavicIcon.Initialize(File.DirAssets, \"mavic.jpg\")";
parent.mostCurrent._mavicicon.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"mavic.jpg");
 //BA.debugLineNum = 99;BA.debugLine="WaypointMissionRunning=False";
parent._waypointmissionrunning = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 100;BA.debugLine="If FirstTime Then";
if (true) break;

case 1:
//if
this.state = 14;
if (_firsttime) { 
this.state = 3;
}if (true) break;

case 3:
//C
this.state = 4;
 //BA.debugLineNum = 102;BA.debugLine="RCSignalStrenghtMavic=22";
parent._rcsignalstrenghtmavic = (int) (22);
 //BA.debugLineNum = 103;BA.debugLine="ssc=0";
parent._ssc = (int) (0);
 //BA.debugLineNum = 105;BA.debugLine="gpsClient.Initialize(\"gpsClient\")";
parent._gpsclient.Initialize("gpsClient");
 //BA.debugLineNum = 106;BA.debugLine="userLocation.Initialize";
parent._userlocation.Initialize();
 //BA.debugLineNum = 108;BA.debugLine="If MapFragment1.IsGooglePlayServicesAvailable =";
if (true) break;

case 4:
//if
this.state = 7;
if (parent.mostCurrent._mapfragment1.IsGooglePlayServicesAvailable(mostCurrent.activityBA)==anywheresoftware.b4a.keywords.Common.False) { 
this.state = 6;
}if (true) break;

case 6:
//C
this.state = 7;
 //BA.debugLineNum = 109;BA.debugLine="ToastMessageShow(\"Please install Google Play Se";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Please install Google Play Services."),anywheresoftware.b4a.keywords.Common.True);
 if (true) break;

case 7:
//C
this.state = 8;
;
 //BA.debugLineNum = 112;BA.debugLine="ShowTelemety";
_showtelemety();
 //BA.debugLineNum = 114;BA.debugLine="sdk.Initialize(\"sdk\")";
parent._sdk.Initialize(processBA,"sdk");
 //BA.debugLineNum = 115;BA.debugLine="timer1.Initialize(\"timer1\", 300)";
parent._timer1.Initialize(processBA,"timer1",(long) (300));
 //BA.debugLineNum = 116;BA.debugLine="UpdateMapTimer.Initialize(\"UpdateMapTimer\",2000)";
parent._updatemaptimer.Initialize(processBA,"UpdateMapTimer",(long) (2000));
 //BA.debugLineNum = 119;BA.debugLine="Wait For SDK_RegisteredResult (Success As Boolea";
anywheresoftware.b4a.keywords.Common.WaitFor("sdk_registeredresult", processBA, this, null);
this.state = 15;
return;
case 15:
//C
this.state = 8;
_success = (Boolean) result[0];
_errormessage = (String) result[1];
;
 //BA.debugLineNum = 120;BA.debugLine="If Success Then";
if (true) break;

case 8:
//if
this.state = 13;
if (_success) { 
this.state = 10;
}else {
this.state = 12;
}if (true) break;

case 10:
//C
this.state = 13;
 //BA.debugLineNum = 121;BA.debugLine="Log(\"Registered successfully!\")";
anywheresoftware.b4a.keywords.Common.Log("Registered successfully!");
 //BA.debugLineNum = 122;BA.debugLine="sdk.StartConnectionToProduct";
parent._sdk.StartConnectionToProduct();
 if (true) break;

case 12:
//C
this.state = 13;
 //BA.debugLineNum = 124;BA.debugLine="Log(ErrorMessage)";
anywheresoftware.b4a.keywords.Common.Log(_errormessage);
 if (true) break;

case 13:
//C
this.state = 14;
;
 if (true) break;

case 14:
//C
this.state = -1;
;
 //BA.debugLineNum = 129;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _sdk_registeredresult(boolean _success,String _errormessage) throws Exception{
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 257;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 258;BA.debugLine="timer1.Enabled = False";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 259;BA.debugLine="pnlCamera.RemoveAllViews 'remove the video feed v";
mostCurrent._pnlcamera.RemoveAllViews();
 //BA.debugLineNum = 260;BA.debugLine="pws.ReleaseKeepAlive";
_pws.ReleaseKeepAlive();
 //BA.debugLineNum = 261;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 252;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 253;BA.debugLine="If sdk.Registered Then sdk.StartConnectionToProdu";
if (_sdk.getRegistered()) { 
_sdk.StartConnectionToProduct();};
 //BA.debugLineNum = 254;BA.debugLine="pws.KeepAlive(True)";
_pws.KeepAlive(processBA,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 255;BA.debugLine="End Sub";
return "";
}
public static void  _afteraircraftconnected() throws Exception{
ResumableSub_AfterAircraftConnected rsub = new ResumableSub_AfterAircraftConnected(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_AfterAircraftConnected extends BA.ResumableSub {
public ResumableSub_AfterAircraftConnected(b4a.dji.waldo.main parent) {
this.parent = parent;
}
b4a.dji.waldo.main parent;
boolean _success = false;
String _errormessage = "";
Object _value = null;
anywheresoftware.b4j.object.JavaObject _jo = null;
anywheresoftware.b4j.object.JavaObject _airlink = null;
anywheresoftware.b4j.object.JavaObject _synclink = null;
Object _event = null;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
                return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 206;BA.debugLine="If aircraft.CameraReady = False Or aircraft.Batte";
if (true) break;

case 1:
//if
this.state = 10;
if (parent._aircraft.getCameraReady()==anywheresoftware.b4a.keywords.Common.False || parent._aircraft.getBatteryReady()==anywheresoftware.b4a.keywords.Common.False) { 
this.state = 3;
}if (true) break;

case 3:
//C
this.state = 4;
 //BA.debugLineNum = 207;BA.debugLine="Log(\"Camera / battery not ready\")";
anywheresoftware.b4a.keywords.Common.Log("Camera / battery not ready");
 //BA.debugLineNum = 208;BA.debugLine="Sleep(500)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (500));
this.state = 15;
return;
case 15:
//C
this.state = 4;
;
 //BA.debugLineNum = 209;BA.debugLine="If aircraft.Connected Then AfterAircraftConnecte";
if (true) break;

case 4:
//if
this.state = 9;
if (parent._aircraft.getConnected()) { 
this.state = 6;
;}if (true) break;

case 6:
//C
this.state = 9;
_afteraircraftconnected();
if (true) break;

case 9:
//C
this.state = 10;
;
 //BA.debugLineNum = 210;BA.debugLine="Return";
if (true) return ;
 if (true) break;

case 10:
//C
this.state = 11;
;
 //BA.debugLineNum = 212;BA.debugLine="aircraft.RegisterBatteryStateEvent";
parent._aircraft.RegisterBatteryStateEvent();
 //BA.debugLineNum = 213;BA.debugLine="controller.Initialize(\"controller\", aircraft)";
parent._controller.Initialize(processBA,"controller",parent._aircraft);
 //BA.debugLineNum = 214;BA.debugLine="Log($\"simulator: ${controller.SimulatorStarted)}\"";
anywheresoftware.b4a.keywords.Common.Log(("simulator: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(parent._controller.getSimulatorStarted())))+"");
 //BA.debugLineNum = 215;BA.debugLine="camera.Initialize(\"camera\", aircraft)";
parent._camera.Initialize(processBA,"camera",parent._aircraft);
 //BA.debugLineNum = 216;BA.debugLine="pnlCamera.AddView(camera.CreateVideoView, 0, 0, p";
parent.mostCurrent._pnlcamera.AddView((android.view.View)(parent._camera.CreateVideoView().getObject()),(int) (0),(int) (0),parent.mostCurrent._pnlcamera.getWidth(),parent.mostCurrent._pnlcamera.getHeight());
 //BA.debugLineNum = 218;BA.debugLine="timer1.Enabled = True";
parent._timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 220;BA.debugLine="WaypointOperator.Initialize(\"WaypointOperator\")";
parent._waypointoperator.Initialize(processBA,"WaypointOperator");
 //BA.debugLineNum = 221;BA.debugLine="aircraftName = \"N/A\"";
parent._aircraftname = "N/A";
 //BA.debugLineNum = 222;BA.debugLine="Wait for (aircraft.GetName) Aircraft_ResultWithVa";
anywheresoftware.b4a.keywords.Common.WaitFor("aircraft_resultwithvalue", processBA, this, parent._aircraft.GetName(processBA));
this.state = 16;
return;
case 16:
//C
this.state = 11;
_success = (Boolean) result[0];
_errormessage = (String) result[1];
_value = (Object) result[2];
;
 //BA.debugLineNum = 223;BA.debugLine="If Success Then";
if (true) break;

case 11:
//if
this.state = 14;
if (_success) { 
this.state = 13;
}if (true) break;

case 13:
//C
this.state = 14;
 //BA.debugLineNum = 224;BA.debugLine="aircraftName = Value";
parent._aircraftname = BA.ObjectToString(_value);
 if (true) break;

case 14:
//C
this.state = -1;
;
 //BA.debugLineNum = 229;BA.debugLine="Dim jo As JavaObject = aircraft";
_jo = new anywheresoftware.b4j.object.JavaObject();
_jo.setObject((java.lang.Object)(parent._aircraft.getObject()));
 //BA.debugLineNum = 230;BA.debugLine="Dim airlink As JavaObject = jo.RunMethod(\"getAirL";
_airlink = new anywheresoftware.b4j.object.JavaObject();
_airlink.setObject((java.lang.Object)(_jo.RunMethod("getAirLink",(Object[])(anywheresoftware.b4a.keywords.Common.Null))));
 //BA.debugLineNum = 232;BA.debugLine="Dim synclink As JavaObject = airlink.RunMethod(\"g";
_synclink = new anywheresoftware.b4j.object.JavaObject();
_synclink.setObject((java.lang.Object)(_airlink.RunMethod("getOcuSyncLink",(Object[])(anywheresoftware.b4a.keywords.Common.Null))));
 //BA.debugLineNum = 235;BA.debugLine="Labelssc.Text=\"link: \" & synclink";
parent.mostCurrent._labelssc.setText(BA.ObjectToCharSequence("link: "+BA.ObjectToString(_synclink)));
 //BA.debugLineNum = 237;BA.debugLine="Dim event As Object = airlink.CreateEventFromUI(\"";
_event = _airlink.CreateEventFromUI(processBA,"dji.common.airlink.SignalQualityCallback","DownloadSignalChanged",anywheresoftware.b4a.keywords.Common.Null);
 //BA.debugLineNum = 238;BA.debugLine="synclink.RunMethod(\"setDownlinkSignalQualityCallb";
_synclink.RunMethod("setDownlinkSignalQualityCallback",new Object[]{_event});
 //BA.debugLineNum = 240;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _aircraft_resultwithvalue(boolean _success,String _errormessage,Object _value) throws Exception{
}
public static String  _aircraft_batterystate(Object _battery,int _remainingpercentage) throws Exception{
 //BA.debugLineNum = 201;BA.debugLine="Sub Aircraft_BatteryState (battery As Object, Rema";
 //BA.debugLineNum = 202;BA.debugLine="batteryLevel = RemainingPercentage";
_batterylevel = _remainingpercentage;
 //BA.debugLineNum = 203;BA.debugLine="End Sub";
return "";
}
public static String  _aircraft_productconnectivitychanged(boolean _connected) throws Exception{
 //BA.debugLineNum = 190;BA.debugLine="Sub Aircraft_ProductConnectivityChanged (Connected";
 //BA.debugLineNum = 191;BA.debugLine="Log($\"Aircraft_ProductConnectivityChanged: ${Conn";
anywheresoftware.b4a.keywords.Common.Log(("Aircraft_ProductConnectivityChanged: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_connected))+""));
 //BA.debugLineNum = 192;BA.debugLine="If Connected Then";
if (_connected) { 
 //BA.debugLineNum = 193;BA.debugLine="AfterAircraftConnected";
_afteraircraftconnected();
 }else {
 //BA.debugLineNum = 195;BA.debugLine="Log(\"Aircraft disconnected!\")";
anywheresoftware.b4a.keywords.Common.Log("Aircraft disconnected!");
 //BA.debugLineNum = 196;BA.debugLine="lblText.Text = $\"Disconnected!!!\"$";
mostCurrent._lbltext.setText(BA.ObjectToCharSequence(("Disconnected!!!")));
 //BA.debugLineNum = 197;BA.debugLine="timer1.Enabled = False";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 };
 //BA.debugLineNum = 199;BA.debugLine="End Sub";
return "";
}
public static anywheresoftware.b4a.objects.CSBuilder  _appendif(anywheresoftware.b4a.objects.CSBuilder _sb,String _condition,String _text) throws Exception{
 //BA.debugLineNum = 370;BA.debugLine="Sub AppendIf(sb As CSBuilder, Condition As String,";
 //BA.debugLineNum = 371;BA.debugLine="If Condition Then sb.Append(Text).Append(CRLF)";
if (BA.ObjectToBoolean(_condition)) { 
_sb.Append(BA.ObjectToCharSequence(_text)).Append(BA.ObjectToCharSequence(anywheresoftware.b4a.keywords.Common.CRLF));};
 //BA.debugLineNum = 372;BA.debugLine="Return sb";
if (true) return _sb;
 //BA.debugLineNum = 373;BA.debugLine="End Sub";
return null;
}
public static String  _controller_imustatechanged(anywheresoftware.b4a.objects.DJIFlightControllerWrapper.DJIIMUStateWrapper _state) throws Exception{
anywheresoftware.b4a.objects.CSBuilder _sb = null;
 //BA.debugLineNum = 385;BA.debugLine="Sub Controller_IMUStateChanged (State As DJIIMUSta";
 //BA.debugLineNum = 386;BA.debugLine="If State.AccelerometerStatus = \"\" Then Return";
if ((_state.getAccelerometerStatus()).equals("")) { 
if (true) return "";};
 //BA.debugLineNum = 387;BA.debugLine="Dim sb As CSBuilder";
_sb = new anywheresoftware.b4a.objects.CSBuilder();
 //BA.debugLineNum = 388;BA.debugLine="sb.Initialize";
_sb.Initialize();
 //BA.debugLineNum = 389;BA.debugLine="AppendIf(sb, State.AccelerometerStatus <> \"NORMAL";
_appendif(_sb,BA.ObjectToString((_state.getAccelerometerStatus()).equals("NORMAL_BIAS") == false),("Acceleromter: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_state.getAccelerometerStatus()))+""));
 //BA.debugLineNum = 390;BA.debugLine="AppendIf(sb, State.CalibrationStatus <> \"NONE\", $";
_appendif(_sb,BA.ObjectToString((_state.getCalibrationStatus()).equals("NONE") == false),("Calibration: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_state.getCalibrationStatus()))+""));
 //BA.debugLineNum = 391;BA.debugLine="AppendIf(sb, State.GyroscopeState <> \"NORMAL_BIAS";
_appendif(_sb,BA.ObjectToString((_state.getGyroscopeState()).equals("NORMAL_BIAS") == false),("Gyroscope: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_state.getGyroscopeState()))+""));
 //BA.debugLineNum = 392;BA.debugLine="IMU = sb";
_imu = BA.ObjectToString(_sb);
 //BA.debugLineNum = 393;BA.debugLine="End Sub";
return "";
}
public static anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper.WaypointWrapper  _createwaypoint(double _lat,double _lon,float _altitude) throws Exception{
anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper.WaypointWrapper _wp = null;
 //BA.debugLineNum = 523;BA.debugLine="Sub CreateWaypoint(Lat As Double, Lon As Double, A";
 //BA.debugLineNum = 524;BA.debugLine="Dim wp As DJIWaypoint";
_wp = new anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper.WaypointWrapper();
 //BA.debugLineNum = 525;BA.debugLine="wp.Initialize(Lat, Lon, Altitude)";
_wp.Initialize(_lat,_lon,_altitude);
 //BA.debugLineNum = 526;BA.debugLine="Return wp";
if (true) return _wp;
 //BA.debugLineNum = 527;BA.debugLine="End Sub";
return null;
}
public static Object  _downloadsignalchanged_event(String _methodname,Object[] _args) throws Exception{
int _strength = 0;
 //BA.debugLineNum = 242;BA.debugLine="Sub DownloadSignalChanged_Event (MethodName As Str";
 //BA.debugLineNum = 243;BA.debugLine="Dim strength As Int = Args(0)";
_strength = (int)(BA.ObjectToNumber(_args[(int) (0)]));
 //BA.debugLineNum = 245;BA.debugLine="RCSignalStrenghtMavic=strength";
_rcsignalstrenghtmavic = _strength;
 //BA.debugLineNum = 246;BA.debugLine="ssc=ssc+1";
_ssc = (int) (_ssc+1);
 //BA.debugLineNum = 247;BA.debugLine="Labelssc.text= \"ss calls:  \" & ssc";
mostCurrent._labelssc.setText(BA.ObjectToCharSequence("ss calls:  "+BA.NumberToString(_ssc)));
 //BA.debugLineNum = 249;BA.debugLine="Return Null";
if (true) return anywheresoftware.b4a.keywords.Common.Null;
 //BA.debugLineNum = 250;BA.debugLine="End Sub";
return null;
}
public static anywheresoftware.b4j.object.JavaObject  _getnativecamera() throws Exception{
anywheresoftware.b4j.object.JavaObject _jo = null;
 //BA.debugLineNum = 572;BA.debugLine="Sub GetNativeCamera As JavaObject";
 //BA.debugLineNum = 573;BA.debugLine="Dim jo As JavaObject = camera";
_jo = new anywheresoftware.b4j.object.JavaObject();
_jo.setObject((java.lang.Object)(_camera));
 //BA.debugLineNum = 574;BA.debugLine="Return jo.GetFieldJO(\"camera\")";
if (true) return _jo.GetFieldJO("camera");
 //BA.debugLineNum = 575;BA.debugLine="End Sub";
return null;
}
public static String  _getuserlocation() throws Exception{
 //BA.debugLineNum = 396;BA.debugLine="Sub GetUserLocation";
 //BA.debugLineNum = 397;BA.debugLine="If gpsClient.GPSEnabled=False Then";
if (_gpsclient.getGPSEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 398;BA.debugLine="ToastMessageShow(\"Please enable your device's GP";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Please enable your device's GPS capabilities"),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 399;BA.debugLine="StartActivity(gpsClient.LocationSettingsIntent)";
anywheresoftware.b4a.keywords.Common.StartActivity(processBA,(Object)(_gpsclient.getLocationSettingsIntent()));
 }else {
 //BA.debugLineNum = 401;BA.debugLine="gpsClient.Start(0, 0)";
_gpsclient.Start(processBA,(long) (0),(float) (0));
 //BA.debugLineNum = 402;BA.debugLine="ProgressDialogShow(\"Waiting for GPS location\")";
anywheresoftware.b4a.keywords.Common.ProgressDialogShow(mostCurrent.activityBA,BA.ObjectToCharSequence("Waiting for GPS location"));
 };
 //BA.debugLineNum = 404;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 65;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 66;BA.debugLine="Private pnlCamera As Panel";
mostCurrent._pnlcamera = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 67;BA.debugLine="Private lblText As Label";
mostCurrent._lbltext = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 68;BA.debugLine="Dim LabelAircraftName As Label";
mostCurrent._labelaircraftname = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 69;BA.debugLine="Dim LabelBattery As Label";
mostCurrent._labelbattery = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 70;BA.debugLine="Dim LabelGPSStatus As Label";
mostCurrent._labelgpsstatus = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 71;BA.debugLine="Dim LabelFlightMode As Label";
mostCurrent._labelflightmode = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 72;BA.debugLine="Dim LabelAltitude As Label";
mostCurrent._labelaltitude = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 73;BA.debugLine="Dim LabelVerticalSpeed As Label";
mostCurrent._labelverticalspeed = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 74;BA.debugLine="Dim LabelSpeed As Label";
mostCurrent._labelspeed = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 75;BA.debugLine="Dim LabelRCSignalStrength As Label";
mostCurrent._labelrcsignalstrength = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 76;BA.debugLine="Dim LabelHomeLocationSet As Label";
mostCurrent._labelhomelocationset = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 77;BA.debugLine="Dim Labelssc As Label";
mostCurrent._labelssc = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 78;BA.debugLine="Private gmap As GoogleMap";
mostCurrent._gmap = new anywheresoftware.b4a.objects.MapFragmentWrapper.GoogleMapWrapper();
 //BA.debugLineNum = 79;BA.debugLine="Private MapFragment1 As MapFragment";
mostCurrent._mapfragment1 = new anywheresoftware.b4a.objects.MapFragmentWrapper();
 //BA.debugLineNum = 81;BA.debugLine="Private StartMissionButton As Button";
mostCurrent._startmissionbutton = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 82;BA.debugLine="Private StopMissionButton As Button";
mostCurrent._stopmissionbutton = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 84;BA.debugLine="Dim HomeIcon As Bitmap";
mostCurrent._homeicon = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 85;BA.debugLine="Dim WaypointIcon As Bitmap";
mostCurrent._waypointicon = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 86;BA.debugLine="Dim MavicIcon As Bitmap";
mostCurrent._mavicicon = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 88;BA.debugLine="Dim WaypointMissionRunning As Boolean";
_waypointmissionrunning = false;
 //BA.debugLineNum = 89;BA.debugLine="End Sub";
return "";
}
public static void  _gotopoint(anywheresoftware.b4a.objects.MapFragmentWrapper.LatLngWrapper _point,float _altitude) throws Exception{
ResumableSub_GoToPoint rsub = new ResumableSub_GoToPoint(null,_point,_altitude);
rsub.resume(processBA, null);
}
public static class ResumableSub_GoToPoint extends BA.ResumableSub {
public ResumableSub_GoToPoint(b4a.dji.waldo.main parent,anywheresoftware.b4a.objects.MapFragmentWrapper.LatLngWrapper _point,float _altitude) {
this.parent = parent;
this._point = _point;
this._altitude = _altitude;
}
b4a.dji.waldo.main parent;
anywheresoftware.b4a.objects.MapFragmentWrapper.LatLngWrapper _point;
float _altitude;
anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper.WaypointMissionBuilderWrapper _builder = null;
anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper.WaypointWrapper _wp = null;
boolean _success = false;
String _errormessage = "";

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
                return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 427;BA.debugLine="Dim builder As DJIWaypointMissionBuilder";
_builder = new anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper.WaypointMissionBuilderWrapper();
 //BA.debugLineNum = 431;BA.debugLine="builder.Initialize";
_builder.Initialize();
 //BA.debugLineNum = 432;BA.debugLine="builder.AutoFlightSpeed = 14 ' is m/s  because wa";
_builder.setAutoFlightSpeed((float) (14));
 //BA.debugLineNum = 433;BA.debugLine="builder.MaxFlightSpeed = 15";
_builder.setMaxFlightSpeed((float) (15));
 //BA.debugLineNum = 437;BA.debugLine="builder.AddWaypoint(CreateWaypoint(Point.Latitude";
_builder.AddWaypoint(_createwaypoint(_point.getLatitude(),_point.getLongitude(),(float) (_altitude*0.3048)));
 //BA.debugLineNum = 440;BA.debugLine="Dim wp As DJIWaypoint = CreateWaypoint(HomeLocati";
_wp = new anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper.WaypointWrapper();
_wp = _createwaypoint(parent._homelocationlatitudemavic,parent._homelocationlongitudemavic,(float) (_altitude*0.3048));
 //BA.debugLineNum = 441;BA.debugLine="wp.AddAction(\"STAY\", 3000)";
_wp.AddAction(BA.getEnumFromString(dji.common.mission.waypoint.WaypointActionType.class,"STAY"),(int) (3000));
 //BA.debugLineNum = 444;BA.debugLine="builder.AddWaypoint(wp)";
_builder.AddWaypoint(_wp);
 //BA.debugLineNum = 446;BA.debugLine="builder.SetFinishAction(\"GO_HOME\")";
_builder.SetFinishAction(BA.getEnumFromString(dji.common.mission.waypoint.WaypointMissionFinishedAction.class,"GO_HOME"));
 //BA.debugLineNum = 447;BA.debugLine="WaypointOperator.LoadMission(builder)";
parent._waypointoperator.LoadMission(_builder);
 //BA.debugLineNum = 448;BA.debugLine="Wait For (WaypointOperator.UploadMission) Waypoin";
anywheresoftware.b4a.keywords.Common.WaitFor("waypointoperator_result", processBA, this, parent._waypointoperator.UploadMission());
this.state = 7;
return;
case 7:
//C
this.state = 1;
_success = (Boolean) result[0];
_errormessage = (String) result[1];
;
 //BA.debugLineNum = 449;BA.debugLine="If Success Then";
if (true) break;

case 1:
//if
this.state = 6;
if (_success) { 
this.state = 3;
}else {
this.state = 5;
}if (true) break;

case 3:
//C
this.state = 6;
 //BA.debugLineNum = 450;BA.debugLine="Sleep(1000) '<--- required. Otherwise it will fa";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (1000));
this.state = 8;
return;
case 8:
//C
this.state = 6;
;
 //BA.debugLineNum = 451;BA.debugLine="Wait For (WaypointOperator.StartMission) Waypoin";
anywheresoftware.b4a.keywords.Common.WaitFor("waypointoperator_result", processBA, this, parent._waypointoperator.StartMission());
this.state = 9;
return;
case 9:
//C
this.state = 6;
_success = (Boolean) result[0];
_errormessage = (String) result[1];
;
 //BA.debugLineNum = 452;BA.debugLine="Labelssc.Text=\"Start: \" & Success & \", \" & Error";
parent.mostCurrent._labelssc.setText(BA.ObjectToCharSequence("Start: "+BA.ObjectToString(_success)+", "+_errormessage));
 //BA.debugLineNum = 453;BA.debugLine="MissionState(True)";
_missionstate(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 454;BA.debugLine="WaypointMissionRunning=True";
parent._waypointmissionrunning = anywheresoftware.b4a.keywords.Common.True;
 if (true) break;

case 5:
//C
this.state = 6;
 //BA.debugLineNum = 456;BA.debugLine="Labelssc.Text=\"Error uploading: \" & ErrorMessage";
parent.mostCurrent._labelssc.setText(BA.ObjectToCharSequence("Error uploading: "+_errormessage));
 if (true) break;

case 6:
//C
this.state = -1;
;
 //BA.debugLineNum = 458;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _waypointoperator_result(boolean _success,String _errormessage) throws Exception{
}
public static String  _mapfragment1_longclick(anywheresoftware.b4a.objects.MapFragmentWrapper.LatLngWrapper _point) throws Exception{
 //BA.debugLineNum = 408;BA.debugLine="Sub MapFragment1_LongClick (Point As LatLng)";
 //BA.debugLineNum = 410;BA.debugLine="If WaypointMissionRunning Then Return";
if (_waypointmissionrunning) { 
if (true) return "";};
 //BA.debugLineNum = 413;BA.debugLine="If WaypointMarker.IsInitialized Then";
if (_waypointmarker.IsInitialized()) { 
 //BA.debugLineNum = 414;BA.debugLine="WaypointMarker.Remove";
_waypointmarker.Remove();
 };
 //BA.debugLineNum = 417;BA.debugLine="WaypointMarker=gmap.AddMarker3(Point.Latitude,Poi";
_waypointmarker = mostCurrent._gmap.AddMarker3(_point.getLatitude(),_point.getLongitude(),"destination",(android.graphics.Bitmap)(mostCurrent._waypointicon.getObject()));
 //BA.debugLineNum = 419;BA.debugLine="GoToPoint(Point,400.0)";
_gotopoint(_point,(float) (400.0));
 //BA.debugLineNum = 420;BA.debugLine="End Sub";
return "";
}
public static String  _mapfragment1_ready() throws Exception{
 //BA.debugLineNum = 133;BA.debugLine="Sub MapFragment1_Ready";
 //BA.debugLineNum = 135;BA.debugLine="gmap = MapFragment1.GetMap";
mostCurrent._gmap = mostCurrent._mapfragment1.GetMap();
 //BA.debugLineNum = 137;BA.debugLine="cp.Initialize( 15.166984 , 120.591976  ,14.0)  '";
_cp.Initialize(15.166984,120.591976,(float) (14.0));
 //BA.debugLineNum = 139;BA.debugLine="gmap.AnimateCamera(cp)";
mostCurrent._gmap.AnimateCamera((com.google.android.gms.maps.model.CameraPosition)(_cp.getObject()));
 //BA.debugLineNum = 140;BA.debugLine="Zoom=cp.Zoom";
_zoom = _cp.getZoom();
 //BA.debugLineNum = 142;BA.debugLine="gmap.MapType=4   ''MAP_TYPE hybrid";
mostCurrent._gmap.setMapType((int) (4));
 //BA.debugLineNum = 144;BA.debugLine="MavicMarker=gmap.AddMarker3(15.176984 , 120.59197";
_mavicmarker = mostCurrent._gmap.AddMarker3(15.176984,120.591976,"Mavic",(android.graphics.Bitmap)(mostCurrent._mavicicon.getObject()));
 //BA.debugLineNum = 145;BA.debugLine="HomeMarker=gmap.AddMarker3(15.166984 , 120.591976";
_homemarker = mostCurrent._gmap.AddMarker3(15.166984,120.591976,"Home",(android.graphics.Bitmap)(mostCurrent._homeicon.getObject()));
 //BA.debugLineNum = 149;BA.debugLine="LabelFlightMode.Text=\"Flight Mode:  \" & \"hi steve";
mostCurrent._labelflightmode.setText(BA.ObjectToCharSequence("Flight Mode:  "+"hi steve"));
 //BA.debugLineNum = 150;BA.debugLine="End Sub";
return "";
}
public static String  _missionstate(boolean _running) throws Exception{
 //BA.debugLineNum = 538;BA.debugLine="Sub MissionState(Running As Boolean)";
 //BA.debugLineNum = 539;BA.debugLine="StartMissionButton.Enabled = Not(Running)";
mostCurrent._startmissionbutton.setEnabled(anywheresoftware.b4a.keywords.Common.Not(_running));
 //BA.debugLineNum = 540;BA.debugLine="StopMissionButton.Enabled = Running";
mostCurrent._stopmissionbutton.setEnabled(_running);
 //BA.debugLineNum = 541;BA.debugLine="End Sub";
return "";
}
public static String  _pnlcamera_touch(int _action,float _x,float _y) throws Exception{
 //BA.debugLineNum = 548;BA.debugLine="Sub pnlCamera_Touch (Action As Int, X As Float, Y";
 //BA.debugLineNum = 549;BA.debugLine="If Action = Activity.ACTION_UP Then";
if (_action==mostCurrent._activity.ACTION_UP) { 
 //BA.debugLineNum = 551;BA.debugLine="SetCameraFocusTarget(0.5, 0.5)";
_setcamerafocustarget((float) (0.5),(float) (0.5));
 };
 //BA.debugLineNum = 553;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
starter._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 19;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 20;BA.debugLine="Private sdk As DJISDKManager";
_sdk = new anywheresoftware.b4a.objects.DJISDKManagerWrapper();
 //BA.debugLineNum = 21;BA.debugLine="Private timer1 As Timer";
_timer1 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 22;BA.debugLine="Private UpdateMapTimer As Timer";
_updatemaptimer = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 23;BA.debugLine="Private aircraft As DJIAircraft";
_aircraft = new anywheresoftware.b4a.objects.DJIAircraftWrapper();
 //BA.debugLineNum = 24;BA.debugLine="Private controller As DJIFlightController";
_controller = new anywheresoftware.b4a.objects.DJIFlightControllerWrapper();
 //BA.debugLineNum = 25;BA.debugLine="Private camera As DJICamera";
_camera = new anywheresoftware.b4a.objects.DJICameraWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Private aircraftName As String";
_aircraftname = "";
 //BA.debugLineNum = 27;BA.debugLine="Private batteryLevel As Int";
_batterylevel = 0;
 //BA.debugLineNum = 28;BA.debugLine="Dim cp As CameraPosition";
_cp = new anywheresoftware.b4a.objects.MapFragmentWrapper.CameraPositionWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Private FlightModeMavic As String";
_flightmodemavic = "";
 //BA.debugLineNum = 30;BA.debugLine="Private GPSStatusMavic As Int";
_gpsstatusmavic = 0;
 //BA.debugLineNum = 31;BA.debugLine="Private AltitudeMavic As Int";
_altitudemavic = 0;
 //BA.debugLineNum = 32;BA.debugLine="Private SpeedMavic As Int";
_speedmavic = 0;
 //BA.debugLineNum = 33;BA.debugLine="Private RateOfClimbMavic As Int";
_rateofclimbmavic = 0;
 //BA.debugLineNum = 34;BA.debugLine="Private HomeLocationSetMavic As Boolean";
_homelocationsetmavic = false;
 //BA.debugLineNum = 35;BA.debugLine="Private RCSignalStrenghtMavic As Int";
_rcsignalstrenghtmavic = 0;
 //BA.debugLineNum = 36;BA.debugLine="Private LatitudeMavic As Double";
_latitudemavic = 0;
 //BA.debugLineNum = 37;BA.debugLine="Private LongitudeMavic As Double";
_longitudemavic = 0;
 //BA.debugLineNum = 38;BA.debugLine="Private HomeLocationSetMavic As Boolean";
_homelocationsetmavic = false;
 //BA.debugLineNum = 39;BA.debugLine="Private HomeLocationLatitudeMavic As Double";
_homelocationlatitudemavic = 0;
 //BA.debugLineNum = 40;BA.debugLine="Private HomeLocationLongitudeMavic As Double";
_homelocationlongitudemavic = 0;
 //BA.debugLineNum = 41;BA.debugLine="Private LastLongitudeMavic As Double";
_lastlongitudemavic = 0;
 //BA.debugLineNum = 42;BA.debugLine="Private LastLatitudeMavic As Double";
_lastlatitudemavic = 0;
 //BA.debugLineNum = 43;BA.debugLine="Private HomeLocationDrawn As Boolean";
_homelocationdrawn = false;
 //BA.debugLineNum = 44;BA.debugLine="Dim Zoom As Float";
_zoom = 0f;
 //BA.debugLineNum = 45;BA.debugLine="Dim ssc As Int";
_ssc = 0;
 //BA.debugLineNum = 46;BA.debugLine="Dim MavicMarker As Marker";
_mavicmarker = new anywheresoftware.b4a.objects.MapFragmentWrapper.MarkerWrapper();
 //BA.debugLineNum = 47;BA.debugLine="Dim WaypointMarker As Marker";
_waypointmarker = new anywheresoftware.b4a.objects.MapFragmentWrapper.MarkerWrapper();
 //BA.debugLineNum = 48;BA.debugLine="Dim HomeMarker As Marker";
_homemarker = new anywheresoftware.b4a.objects.MapFragmentWrapper.MarkerWrapper();
 //BA.debugLineNum = 49;BA.debugLine="Private IMU As String";
_imu = "";
 //BA.debugLineNum = 50;BA.debugLine="Private pws As PhoneWakeState";
_pws = new anywheresoftware.b4a.phone.Phone.PhoneWakeState();
 //BA.debugLineNum = 51;BA.debugLine="Dim gpsClient As GPS";
_gpsclient = new anywheresoftware.b4a.gps.GPS();
 //BA.debugLineNum = 52;BA.debugLine="Dim userLocation As Location";
_userlocation = new anywheresoftware.b4a.gps.LocationWrapper();
 //BA.debugLineNum = 53;BA.debugLine="Private WaypointOperator As DJIWaypointMissionOpe";
_waypointoperator = new anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper();
 //BA.debugLineNum = 54;BA.debugLine="Private MissionStatus As String";
_missionstatus = "";
 //BA.debugLineNum = 56;BA.debugLine="Dim DJICameraCaptureWidget1 As DJICameraCaptureWi";
_djicameracapturewidget1 = new anywheresoftware.b4a.objects.DJICameraCaptureWidgetWrapper();
 //BA.debugLineNum = 57;BA.debugLine="Dim DJIRemoteControlSignalWidget1 As DJIRemoteCon";
_djiremotecontrolsignalwidget1 = new anywheresoftware.b4a.objects.DJIRemoteControlSignalWidgetWrapper();
 //BA.debugLineNum = 58;BA.debugLine="Dim DJIDistanceRCWidget1 As DJIDistanceRCWidget";
_djidistancercwidget1 = new anywheresoftware.b4a.objects.DJIDistanceRCWidgetWrapper();
 //BA.debugLineNum = 59;BA.debugLine="Dim DJIRemainingFlightTimeWidget1 As DJIRemaining";
_djiremainingflighttimewidget1 = new anywheresoftware.b4a.objects.DJIRemainingFlightTimeWidgetWrapper();
 //BA.debugLineNum = 60;BA.debugLine="Dim DJIVerticalVelocityWidget1 As DJIVerticalVelo";
_djiverticalvelocitywidget1 = new anywheresoftware.b4a.objects.DJIVerticalVelocityWidgetWrapper();
 //BA.debugLineNum = 61;BA.debugLine="Dim DJIDashboardWidget1 As DJIDashboardWidget";
_djidashboardwidget1 = new anywheresoftware.b4a.objects.DJIDashboardWidgetWrapper();
 //BA.debugLineNum = 63;BA.debugLine="End Sub";
return "";
}
public static String  _sdk_productchanged(Object _aircraftdata) throws Exception{
 //BA.debugLineNum = 178;BA.debugLine="Sub SDK_ProductChanged (AircraftData As Object)";
 //BA.debugLineNum = 179;BA.debugLine="If AircraftData <> Null Then";
if (_aircraftdata!= null) { 
 //BA.debugLineNum = 180;BA.debugLine="Log(\"Product connected\")";
anywheresoftware.b4a.keywords.Common.Log("Product connected");
 //BA.debugLineNum = 181;BA.debugLine="aircraft.Initialize(\"aircraft\", AircraftData)";
_aircraft.Initialize(processBA,"aircraft",_aircraftdata);
 //BA.debugLineNum = 182;BA.debugLine="If aircraft.Connected Then";
if (_aircraft.getConnected()) { 
 //BA.debugLineNum = 183;BA.debugLine="AfterAircraftConnected";
_afteraircraftconnected();
 };
 }else {
 //BA.debugLineNum = 186;BA.debugLine="Log(\"No connected product\")";
anywheresoftware.b4a.keywords.Common.Log("No connected product");
 };
 //BA.debugLineNum = 188;BA.debugLine="End Sub";
return "";
}
public static void  _setcamerafocustarget(float _x,float _y) throws Exception{
ResumableSub_SetCameraFocusTarget rsub = new ResumableSub_SetCameraFocusTarget(null,_x,_y);
rsub.resume(processBA, null);
}
public static class ResumableSub_SetCameraFocusTarget extends BA.ResumableSub {
public ResumableSub_SetCameraFocusTarget(b4a.dji.waldo.main parent,float _x,float _y) {
this.parent = parent;
this._x = _x;
this._y = _y;
}
b4a.dji.waldo.main parent;
float _x;
float _y;
anywheresoftware.b4j.object.JavaObject _pf = null;
Object _cc = null;
String _methodname = "";
Object[] _args = null;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
                return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 556;BA.debugLine="Dim pf As JavaObject";
_pf = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 557;BA.debugLine="pf.InitializeNewInstance(\"android.graphics.PointF";
_pf.InitializeNewInstance("android.graphics.PointF",new Object[]{(Object)(_x),(Object)(_y)});
 //BA.debugLineNum = 558;BA.debugLine="Dim cc As Object = pf.CreateEventFromUI(\"dji.comm";
_cc = _pf.CreateEventFromUI(processBA,"dji.common.util.CommonCallbacks$CompletionCallback","callback",anywheresoftware.b4a.keywords.Common.Null);
 //BA.debugLineNum = 559;BA.debugLine="GetNativeCamera.RunMethod(\"setFocusTarget\", Array";
_getnativecamera().RunMethod("setFocusTarget",new Object[]{(Object)(_pf.getObject()),_cc});
 //BA.debugLineNum = 560;BA.debugLine="Wait For (pf) Callback_Event (MethodName As Strin";
anywheresoftware.b4a.keywords.Common.WaitFor("callback_event", processBA, this, (Object)(_pf.getObject()));
this.state = 7;
return;
case 7:
//C
this.state = 1;
_methodname = (String) result[0];
_args = (Object[]) result[1];
;
 //BA.debugLineNum = 561;BA.debugLine="If Args(0) = Null Then";
if (true) break;

case 1:
//if
this.state = 6;
if (_args[(int) (0)]== null) { 
this.state = 3;
}else {
this.state = 5;
}if (true) break;

case 3:
//C
this.state = 6;
 //BA.debugLineNum = 562;BA.debugLine="Labelssc.Text=\"Focus set successfully.\"";
parent.mostCurrent._labelssc.setText(BA.ObjectToCharSequence("Focus set successfully."));
 if (true) break;

case 5:
//C
this.state = 6;
 //BA.debugLineNum = 564;BA.debugLine="Labelssc.Text=\"Error setting focus: \" & Args(0)";
parent.mostCurrent._labelssc.setText(BA.ObjectToCharSequence("Error setting focus: "+BA.ObjectToString(_args[(int) (0)])));
 if (true) break;

case 6:
//C
this.state = -1;
;
 //BA.debugLineNum = 567;BA.debugLine="Sleep(3000)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (3000));
this.state = 8;
return;
case 8:
//C
this.state = -1;
;
 //BA.debugLineNum = 568;BA.debugLine="Labelssc.Text=\"\"";
parent.mostCurrent._labelssc.setText(BA.ObjectToCharSequence(""));
 //BA.debugLineNum = 570;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _callback_event(String _methodname,Object[] _args) throws Exception{
}
public static anywheresoftware.b4a.objects.CSBuilder  _setcolor(anywheresoftware.b4a.objects.CSBuilder _sb,boolean _condition) throws Exception{
 //BA.debugLineNum = 365;BA.debugLine="Sub SetColor(sb As CSBuilder, Condition As Boolean";
 //BA.debugLineNum = 366;BA.debugLine="If Condition Then sb.Color(Colors.Red) Else sb.Co";
if (_condition) { 
_sb.Color(anywheresoftware.b4a.keywords.Common.Colors.Red);}
else {
_sb.Color(anywheresoftware.b4a.keywords.Common.Colors.White);};
 //BA.debugLineNum = 367;BA.debugLine="Return sb";
if (true) return _sb;
 //BA.debugLineNum = 368;BA.debugLine="End Sub";
return null;
}
public static void  _sethome() throws Exception{
ResumableSub_SetHome rsub = new ResumableSub_SetHome(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_SetHome extends BA.ResumableSub {
public ResumableSub_SetHome(b4a.dji.waldo.main parent) {
this.parent = parent;
}
b4a.dji.waldo.main parent;
boolean _success = false;
String _errormessage = "";

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
                return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 376;BA.debugLine="Wait For (controller.SetHomeLocationUsingAircraft";
anywheresoftware.b4a.keywords.Common.WaitFor("controller_result", processBA, this, parent._controller.SetHomeLocationUsingAircraftCurrentLocation());
this.state = 7;
return;
case 7:
//C
this.state = 1;
_success = (Boolean) result[0];
_errormessage = (String) result[1];
;
 //BA.debugLineNum = 377;BA.debugLine="If Success Then";
if (true) break;

case 1:
//if
this.state = 6;
if (_success) { 
this.state = 3;
}else {
this.state = 5;
}if (true) break;

case 3:
//C
this.state = 6;
 //BA.debugLineNum = 378;BA.debugLine="Log(\"home set\")";
anywheresoftware.b4a.keywords.Common.Log("home set");
 if (true) break;

case 5:
//C
this.state = 6;
 //BA.debugLineNum = 380;BA.debugLine="Log(\"Error: \" & ErrorMessage)";
anywheresoftware.b4a.keywords.Common.Log("Error: "+_errormessage);
 if (true) break;

case 6:
//C
this.state = -1;
;
 //BA.debugLineNum = 382;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _controller_result(boolean _success,String _errormessage) throws Exception{
}
public static String  _showtelemety() throws Exception{
 //BA.debugLineNum = 264;BA.debugLine="Sub ShowTelemety";
 //BA.debugLineNum = 266;BA.debugLine="LabelAircraftName.Text =  \"Aircraft: \"   & \"waldo";
mostCurrent._labelaircraftname.setText(BA.ObjectToCharSequence("Aircraft: "+"waldo"));
 //BA.debugLineNum = 268;BA.debugLine="LabelBattery.Text=\"Battery: \" & batteryLevel & \"%";
mostCurrent._labelbattery.setText(BA.ObjectToCharSequence("Battery: "+BA.NumberToString(_batterylevel)+"%"));
 //BA.debugLineNum = 270;BA.debugLine="LabelRCSignalStrength.Text=\"RC Strength:  \" & RCS";
mostCurrent._labelrcsignalstrength.setText(BA.ObjectToCharSequence("RC Strength:  "+BA.NumberToString(_rcsignalstrenghtmavic)));
 //BA.debugLineNum = 272;BA.debugLine="If HomeLocationSetMavic Then";
if (_homelocationsetmavic) { 
 //BA.debugLineNum = 273;BA.debugLine="LabelHomeLocationSet.Text=\" HOME LOCATION SET\"";
mostCurrent._labelhomelocationset.setText(BA.ObjectToCharSequence(" HOME LOCATION SET"));
 //BA.debugLineNum = 274;BA.debugLine="LabelHomeLocationSet.TextColor= Colors.Green";
mostCurrent._labelhomelocationset.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Green);
 }else {
 //BA.debugLineNum = 277;BA.debugLine="LabelHomeLocationSet.Text=\" NO HOME SET\"";
mostCurrent._labelhomelocationset.setText(BA.ObjectToCharSequence(" NO HOME SET"));
 //BA.debugLineNum = 278;BA.debugLine="LabelHomeLocationSet.textColor=Colors.Red";
mostCurrent._labelhomelocationset.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 };
 //BA.debugLineNum = 281;BA.debugLine="LabelGPSStatus.Text=\"GPS:  \" & GPSStatusMavic";
mostCurrent._labelgpsstatus.setText(BA.ObjectToCharSequence("GPS:  "+BA.NumberToString(_gpsstatusmavic)));
 //BA.debugLineNum = 283;BA.debugLine="LabelFlightMode.Text=\"Flight Mode:  \" & FlightMod";
mostCurrent._labelflightmode.setText(BA.ObjectToCharSequence("Flight Mode:  "+_flightmodemavic));
 //BA.debugLineNum = 285;BA.debugLine="LabelAltitude.Text=\"Altitude:  \"& AltitudeMavic '";
mostCurrent._labelaltitude.setText(BA.ObjectToCharSequence("Altitude:  "+BA.NumberToString(_altitudemavic)));
 //BA.debugLineNum = 286;BA.debugLine="LabelVerticalSpeed.Text=\"Vert Speed:  \" & RateOfC";
mostCurrent._labelverticalspeed.setText(BA.ObjectToCharSequence("Vert Speed:  "+BA.NumberToString(_rateofclimbmavic)));
 //BA.debugLineNum = 288;BA.debugLine="LabelSpeed.Text=\"Speed:  \" & SpeedMavic  'speed";
mostCurrent._labelspeed.setText(BA.ObjectToCharSequence("Speed:  "+BA.NumberToString(_speedmavic)));
 //BA.debugLineNum = 290;BA.debugLine="End Sub";
return "";
}
public static void  _startmissionbutton_click() throws Exception{
ResumableSub_StartMissionButton_Click rsub = new ResumableSub_StartMissionButton_Click(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_StartMissionButton_Click extends BA.ResumableSub {
public ResumableSub_StartMissionButton_Click(b4a.dji.waldo.main parent) {
this.parent = parent;
}
b4a.dji.waldo.main parent;
anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper.WaypointMissionBuilderWrapper _builder = null;
anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper.WaypointWrapper _wp = null;
boolean _success = false;
String _errormessage = "";

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
                return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 490;BA.debugLine="Return";
if (true) return ;
 //BA.debugLineNum = 492;BA.debugLine="Dim builder As DJIWaypointMissionBuilder";
_builder = new anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper.WaypointMissionBuilderWrapper();
 //BA.debugLineNum = 493;BA.debugLine="builder.Initialize";
_builder.Initialize();
 //BA.debugLineNum = 494;BA.debugLine="builder.AutoFlightSpeed = 10";
_builder.setAutoFlightSpeed((float) (10));
 //BA.debugLineNum = 495;BA.debugLine="builder.MaxFlightSpeed = 15";
_builder.setMaxFlightSpeed((float) (15));
 //BA.debugLineNum = 496;BA.debugLine="builder.AddWaypoint(CreateWaypoint(32.8373372, 35";
_builder.AddWaypoint(_createwaypoint(32.8373372,35.26967794,(float) (40)));
 //BA.debugLineNum = 497;BA.debugLine="Dim wp As DJIWaypoint = CreateWaypoint(32.8385000";
_wp = new anywheresoftware.b4a.objects.WaypointMissionOperatorWrapper.WaypointWrapper();
_wp = _createwaypoint(32.83850007,35.26828855,(float) (30));
 //BA.debugLineNum = 498;BA.debugLine="wp.AddAction(\"STAY\", 3000)";
_wp.AddAction(BA.getEnumFromString(dji.common.mission.waypoint.WaypointActionType.class,"STAY"),(int) (3000));
 //BA.debugLineNum = 499;BA.debugLine="wp.AddAction(\"GIMBAL_PITCH\", -90)";
_wp.AddAction(BA.getEnumFromString(dji.common.mission.waypoint.WaypointActionType.class,"GIMBAL_PITCH"),(int) (-90));
 //BA.debugLineNum = 500;BA.debugLine="wp.AddAction(\"START_TAKE_PHOTO\", 0)";
_wp.AddAction(BA.getEnumFromString(dji.common.mission.waypoint.WaypointActionType.class,"START_TAKE_PHOTO"),(int) (0));
 //BA.debugLineNum = 501;BA.debugLine="builder.AddWaypoint(wp)";
_builder.AddWaypoint(_wp);
 //BA.debugLineNum = 502;BA.debugLine="wp = CreateWaypoint(32.83772032, 35.26845485, 30)";
_wp = _createwaypoint(32.83772032,35.26845485,(float) (30));
 //BA.debugLineNum = 503;BA.debugLine="wp.AddAction(\"GIMBAL_PITCH\", 0)";
_wp.AddAction(BA.getEnumFromString(dji.common.mission.waypoint.WaypointActionType.class,"GIMBAL_PITCH"),(int) (0));
 //BA.debugLineNum = 504;BA.debugLine="wp.AddAction(\"START_RECORD\", 0)";
_wp.AddAction(BA.getEnumFromString(dji.common.mission.waypoint.WaypointActionType.class,"START_RECORD"),(int) (0));
 //BA.debugLineNum = 505;BA.debugLine="builder.AddWaypoint(wp)";
_builder.AddWaypoint(_wp);
 //BA.debugLineNum = 506;BA.debugLine="wp = CreateWaypoint(32.83707127, 35.26887327, 30)";
_wp = _createwaypoint(32.83707127,35.26887327,(float) (30));
 //BA.debugLineNum = 507;BA.debugLine="wp.AddAction(\"STOP_RECORD\", 0)";
_wp.AddAction(BA.getEnumFromString(dji.common.mission.waypoint.WaypointActionType.class,"STOP_RECORD"),(int) (0));
 //BA.debugLineNum = 508;BA.debugLine="builder.AddWaypoint(wp)";
_builder.AddWaypoint(_wp);
 //BA.debugLineNum = 509;BA.debugLine="builder.SetFinishAction(\"GO_FIRST_WAYPOINT\")";
_builder.SetFinishAction(BA.getEnumFromString(dji.common.mission.waypoint.WaypointMissionFinishedAction.class,"GO_FIRST_WAYPOINT"));
 //BA.debugLineNum = 510;BA.debugLine="WaypointOperator.LoadMission(builder)";
parent._waypointoperator.LoadMission(_builder);
 //BA.debugLineNum = 511;BA.debugLine="Wait For (WaypointOperator.UploadMission) Waypoin";
anywheresoftware.b4a.keywords.Common.WaitFor("waypointoperator_result", processBA, this, parent._waypointoperator.UploadMission());
this.state = 7;
return;
case 7:
//C
this.state = 1;
_success = (Boolean) result[0];
_errormessage = (String) result[1];
;
 //BA.debugLineNum = 512;BA.debugLine="If Success Then";
if (true) break;

case 1:
//if
this.state = 6;
if (_success) { 
this.state = 3;
}else {
this.state = 5;
}if (true) break;

case 3:
//C
this.state = 6;
 //BA.debugLineNum = 513;BA.debugLine="Sleep(1000) '<--- required. Otherwise it will fa";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (1000));
this.state = 8;
return;
case 8:
//C
this.state = 6;
;
 //BA.debugLineNum = 514;BA.debugLine="Wait For (WaypointOperator.StartMission) Waypoin";
anywheresoftware.b4a.keywords.Common.WaitFor("waypointoperator_result", processBA, this, parent._waypointoperator.StartMission());
this.state = 9;
return;
case 9:
//C
this.state = 6;
_success = (Boolean) result[0];
_errormessage = (String) result[1];
;
 //BA.debugLineNum = 515;BA.debugLine="Log(\"Start: \" & Success & \", \" & ErrorMessage)";
anywheresoftware.b4a.keywords.Common.Log("Start: "+BA.ObjectToString(_success)+", "+_errormessage);
 //BA.debugLineNum = 516;BA.debugLine="MissionState(True)";
_missionstate(anywheresoftware.b4a.keywords.Common.True);
 if (true) break;

case 5:
//C
this.state = 6;
 //BA.debugLineNum = 518;BA.debugLine="Log(\"Error uploading: \" & ErrorMessage)";
anywheresoftware.b4a.keywords.Common.Log("Error uploading: "+_errormessage);
 //BA.debugLineNum = 519;BA.debugLine="ToastMessageShow(\"Error uploading: \" & ErrorMess";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Error uploading: "+_errormessage),anywheresoftware.b4a.keywords.Common.True);
 if (true) break;

case 6:
//C
this.state = -1;
;
 //BA.debugLineNum = 521;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _stopmissionbutton_click() throws Exception{
ResumableSub_StopMissionButton_Click rsub = new ResumableSub_StopMissionButton_Click(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_StopMissionButton_Click extends BA.ResumableSub {
public ResumableSub_StopMissionButton_Click(b4a.dji.waldo.main parent) {
this.parent = parent;
}
b4a.dji.waldo.main parent;
boolean _success = false;
String _errormessage = "";

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
                return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 465;BA.debugLine="Wait For (WaypointOperator.StopMission) WaypointO";
anywheresoftware.b4a.keywords.Common.WaitFor("waypointoperator_result", processBA, this, parent._waypointoperator.StopMission());
this.state = 7;
return;
case 7:
//C
this.state = 1;
_success = (Boolean) result[0];
_errormessage = (String) result[1];
;
 //BA.debugLineNum = 466;BA.debugLine="If Success = False Then";
if (true) break;

case 1:
//if
this.state = 6;
if (_success==anywheresoftware.b4a.keywords.Common.False) { 
this.state = 3;
}else {
this.state = 5;
}if (true) break;

case 3:
//C
this.state = 6;
 //BA.debugLineNum = 467;BA.debugLine="Labelssc.Text=\"Failed to stop\" & ErrorMessage";
parent.mostCurrent._labelssc.setText(BA.ObjectToCharSequence("Failed to stop"+_errormessage));
 if (true) break;

case 5:
//C
this.state = 6;
 //BA.debugLineNum = 469;BA.debugLine="MissionStatus = \"Mission stopped\"";
parent._missionstatus = "Mission stopped";
 //BA.debugLineNum = 470;BA.debugLine="Labelssc.Text= \"Mission stopped\" & ErrorMessage";
parent.mostCurrent._labelssc.setText(BA.ObjectToCharSequence("Mission stopped"+_errormessage));
 //BA.debugLineNum = 471;BA.debugLine="MissionState(False)";
_missionstate(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 472;BA.debugLine="WaypointMissionRunning=False";
parent._waypointmissionrunning = anywheresoftware.b4a.keywords.Common.False;
 if (true) break;

case 6:
//C
this.state = -1;
;
 //BA.debugLineNum = 474;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static String  _timer1_tick() throws Exception{
anywheresoftware.b4a.objects.DJIFlightControllerCurrentStateWrapper _st = null;
double _speed = 0;
anywheresoftware.b4a.objects.CSBuilder _sb = null;
int _i = 0;
 //BA.debugLineNum = 300;BA.debugLine="Sub Timer1_Tick";
 //BA.debugLineNum = 301;BA.debugLine="If controller.IsInitialized Then";
if (_controller.IsInitialized()) { 
 //BA.debugLineNum = 302;BA.debugLine="Dim St As DJIFlightControllerCurrentState = cont";
_st = new anywheresoftware.b4a.objects.DJIFlightControllerCurrentStateWrapper();
_st = _controller.getCurrentState();
 //BA.debugLineNum = 303;BA.debugLine="Dim speed As Double = Sqrt(Power(St.VelocityX, 2";
_speed = anywheresoftware.b4a.keywords.Common.Sqrt(anywheresoftware.b4a.keywords.Common.Power(_st.getVelocityX(),2)+anywheresoftware.b4a.keywords.Common.Power(_st.getVelocityY(),2));
 //BA.debugLineNum = 304;BA.debugLine="Dim sb As CSBuilder";
_sb = new anywheresoftware.b4a.objects.CSBuilder();
 //BA.debugLineNum = 305;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 308;BA.debugLine="ShowTelemety";
_showtelemety();
 //BA.debugLineNum = 309;BA.debugLine="UpdateMap";
_updatemap();
 //BA.debugLineNum = 311;BA.debugLine="sb.Initialize";
_sb.Initialize();
 //BA.debugLineNum = 312;BA.debugLine="sb.Append($\"Aircraft: ${aircraftName}\"$).Append(";
_sb.Append(BA.ObjectToCharSequence(("Aircraft: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_aircraftname))+""))).Append(BA.ObjectToCharSequence(anywheresoftware.b4a.keywords.Common.CRLF));
 //BA.debugLineNum = 314;BA.debugLine="SetColor(sb, batteryLevel < 30).Append($\"Battery";
_setcolor(_sb,_batterylevel<30).Append(BA.ObjectToCharSequence(("Battery: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_batterylevel))+"%"))).Pop().Append(BA.ObjectToCharSequence(anywheresoftware.b4a.keywords.Common.CRLF));
 //BA.debugLineNum = 316;BA.debugLine="SetColor(sb, St.GPSStatus <> 4 And St.GPSStatus";
_setcolor(_sb,_st.getGPSStatus()!=4 && _st.getGPSStatus()!=5).Append(BA.ObjectToCharSequence(("GPSStatus (5 = good): "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_st.getGPSStatus()))+""))).Pop();
 //BA.debugLineNum = 318;BA.debugLine="GPSStatusMavic=St.GPSStatus";
_gpsstatusmavic = _st.getGPSStatus();
 //BA.debugLineNum = 319;BA.debugLine="FlightModeMavic=St.FlightMode";
_flightmodemavic = _st.getFlightMode();
 //BA.debugLineNum = 320;BA.debugLine="AltitudeMavic=St.AircraftLocation.Altitude * 3.2";
_altitudemavic = (int) (_st.getAircraftLocation().getAltitude()*3.28084);
 //BA.debugLineNum = 321;BA.debugLine="SpeedMavic=speed * 2.23694";
_speedmavic = (int) (_speed*2.23694);
 //BA.debugLineNum = 322;BA.debugLine="RateOfClimbMavic=-St.VelocityZ * 3.28084";
_rateofclimbmavic = (int) (-_st.getVelocityZ()*3.28084);
 //BA.debugLineNum = 323;BA.debugLine="HomeLocationSetMavic=St.HomeLocationSet";
_homelocationsetmavic = _st.getHomeLocationSet();
 //BA.debugLineNum = 324;BA.debugLine="LatitudeMavic=St.AircraftLocation.Latitude";
_latitudemavic = _st.getAircraftLocation().getLatitude();
 //BA.debugLineNum = 325;BA.debugLine="LongitudeMavic=St.AircraftLocation.Longitude";
_longitudemavic = _st.getAircraftLocation().getLongitude();
 //BA.debugLineNum = 326;BA.debugLine="HomeLocationSetMavic=St.HomeLocationSet";
_homelocationsetmavic = _st.getHomeLocationSet();
 //BA.debugLineNum = 328;BA.debugLine="sb.Append(CRLF)";
_sb.Append(BA.ObjectToCharSequence(anywheresoftware.b4a.keywords.Common.CRLF));
 //BA.debugLineNum = 329;BA.debugLine="sb.Append($\"Simulator: ${controller.SimulatorSta";
_sb.Append(BA.ObjectToCharSequence(("Simulator: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_controller.getSimulatorStarted()))+"\n"+"\n"+"	FlightMode: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_st.getFlightMode()))+"\n"+"Altitude: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("1.0",(Object)(_st.getAircraftLocation().getAltitude()))+" m\n"+"Location: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("1.3",(Object)(_st.getAircraftLocation().getLatitude()))+" / "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("1.3",(Object)(_st.getAircraftLocation().getLongitude()))+"\n"+"speed: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("1.0",(Object)(_speed))+" m/s\n"+"VelocityZ: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("1.1",(Object)(-_st.getVelocityZ()))+" m/s\n"+"WaypointOperator: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_waypointoperator.getMissionState()))+"\n"+"")));
 //BA.debugLineNum = 340;BA.debugLine="AppendIf(sb, St.IMUPreheating, $\"IMUPreheating:";
_appendif(_sb,BA.ObjectToString(_st.getIMUPreheating()),("IMUPreheating: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_st.getIMUPreheating()))+""));
 //BA.debugLineNum = 341;BA.debugLine="sb.Append(IMU)";
_sb.Append(BA.ObjectToCharSequence(_imu));
 //BA.debugLineNum = 342;BA.debugLine="SetColor(sb, St.HomeLocationSet = False)";
_setcolor(_sb,_st.getHomeLocationSet()==anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 346;BA.debugLine="If St.HomeLocationSet Then";
if (_st.getHomeLocationSet()) { 
 //BA.debugLineNum = 347;BA.debugLine="sb.Append($\"Home: $1.3{St.HomeLocation.Latitude";
_sb.Append(BA.ObjectToCharSequence(("Home: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("1.3",(Object)(_st.getHomeLocation().getLatitude()))+" / "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("1.3",(Object)(_st.getHomeLocation().getLongitude()))+"")));
 //BA.debugLineNum = 349;BA.debugLine="HomeLocationLatitudeMavic=St.HomeLocation.Latit";
_homelocationlatitudemavic = _st.getHomeLocation().getLatitude();
 //BA.debugLineNum = 350;BA.debugLine="HomeLocationLongitudeMavic=St.HomeLocation.Long";
_homelocationlongitudemavic = _st.getHomeLocation().getLongitude();
 //BA.debugLineNum = 352;BA.debugLine="UpdateMapTimer.Enabled=True";
_updatemaptimer.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 355;BA.debugLine="sb.Append(\"Home: Not set!\")";
_sb.Append(BA.ObjectToCharSequence("Home: Not set!"));
 //BA.debugLineNum = 356;BA.debugLine="If St.GPSStatus = 4 Or St.GPSStatus = 5 Then";
if (_st.getGPSStatus()==4 || _st.getGPSStatus()==5) { 
 //BA.debugLineNum = 357;BA.debugLine="SetHome";
_sethome();
 };
 };
 //BA.debugLineNum = 360;BA.debugLine="sb.Pop";
_sb.Pop();
 //BA.debugLineNum = 361;BA.debugLine="lblText.Text = sb";
mostCurrent._lbltext.setText(BA.ObjectToCharSequence(_sb.getObject()));
 };
 //BA.debugLineNum = 363;BA.debugLine="End Sub";
return "";
}
public static String  _updatemap() throws Exception{
 //BA.debugLineNum = 153;BA.debugLine="Sub UpdateMap";
 //BA.debugLineNum = 156;BA.debugLine="MavicMarker.Remove";
_mavicmarker.Remove();
 //BA.debugLineNum = 158;BA.debugLine="Zoom=cp.Zoom";
_zoom = _cp.getZoom();
 //BA.debugLineNum = 160;BA.debugLine="gmap = MapFragment1.GetMap";
mostCurrent._gmap = mostCurrent._mapfragment1.GetMap();
 //BA.debugLineNum = 162;BA.debugLine="If HomeLocationSetMavic Then";
if (_homelocationsetmavic) { 
 //BA.debugLineNum = 163;BA.debugLine="If HomeLocationDrawn Then";
if (_homelocationdrawn) { 
 }else {
 //BA.debugLineNum = 166;BA.debugLine="HomeLocationDrawn=True";
_homelocationdrawn = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 167;BA.debugLine="HomeMarker.Remove";
_homemarker.Remove();
 //BA.debugLineNum = 168;BA.debugLine="HomeMarker=gmap.AddMarker3(HomeLocationLatitude";
_homemarker = mostCurrent._gmap.AddMarker3(_homelocationlatitudemavic,_homelocationlongitudemavic,"Home",(android.graphics.Bitmap)(mostCurrent._homeicon.getObject()));
 };
 };
 //BA.debugLineNum = 173;BA.debugLine="MavicMarker=gmap.AddMarker3(LatitudeMavic,Longitu";
_mavicmarker = mostCurrent._gmap.AddMarker3(_latitudemavic,_longitudemavic,"Mavic",(android.graphics.Bitmap)(mostCurrent._mavicicon.getObject()));
 //BA.debugLineNum = 174;BA.debugLine="End Sub";
return "";
}
public static String  _updatemaptimer_tick() throws Exception{
 //BA.debugLineNum = 292;BA.debugLine="Sub UpdateMapTimer_Tick";
 //BA.debugLineNum = 294;BA.debugLine="UpdateMap";
_updatemap();
 //BA.debugLineNum = 296;BA.debugLine="End Sub";
return "";
}
public static String  _waypointoperator_missionfinish(String _error) throws Exception{
 //BA.debugLineNum = 533;BA.debugLine="Sub WaypointOperator_MissionFinish (Error As Strin";
 //BA.debugLineNum = 534;BA.debugLine="MissionStatus = \"MissionFinish: \" & Error";
_missionstatus = "MissionFinish: "+_error;
 //BA.debugLineNum = 535;BA.debugLine="MissionState(False)";
_missionstate(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 536;BA.debugLine="End Sub";
return "";
}
public static String  _waypointoperator_missionprogress(Object _executionevent,int _targetwaypointindex) throws Exception{
 //BA.debugLineNum = 543;BA.debugLine="Sub WaypointOperator_MissionProgress (ExecutionEve";
 //BA.debugLineNum = 544;BA.debugLine="MissionStatus = \"Flying to: \" & TargetWaypointInd";
_missionstatus = "Flying to: "+BA.NumberToString(_targetwaypointindex);
 //BA.debugLineNum = 545;BA.debugLine="End Sub";
return "";
}
public static String  _waypointoperator_missionstart() throws Exception{
 //BA.debugLineNum = 529;BA.debugLine="Sub WaypointOperator_MissionStart";
 //BA.debugLineNum = 530;BA.debugLine="MissionStatus = \"MissionStart\"";
_missionstatus = "MissionStart";
 //BA.debugLineNum = 531;BA.debugLine="End Sub";
return "";
}
}
